'use strict';

var vscodeLanguageserverProtocol = require('vscode-languageserver-protocol');
var css = require('@master/css');

const INVOKED_TRIGGER_CHARACTERS = [
    '"',
    ' ',
    '\''
];
const VALUE_TRIGGER_CHARACTERS = [
    css.SEPARATOR_SIGN,
    css.DELIMITER_SIGN
];
const SELECTOR_TRIGGER_CHARACTERS = css.SELECTOR_SIGNS;
const AT_TRIGGER_CHARACTER = css.AT_SIGN;
const QUERY_TRIGGER_CHARACTERS = [
    ...css.QUERY_COMPARISON_OPERATORS,
    ...css.QUERY_LOGICAL_OPERATORS
];
const GROUP_TRIGGER_CHARACTER = '{';
const DECLARATION_SEPARATOR_TRIGGER_CHARACTER = ';';
const SERVER_CAPABILITIES = {
    textDocumentSync: vscodeLanguageserverProtocol.TextDocumentSyncKind.Incremental,
    // Tell the client that this server supports code completion.
    completionProvider: {
        resolveProvider: false,
        workDoneProgress: false,
        triggerCharacters: [
            ...new Set([
                ...INVOKED_TRIGGER_CHARACTERS,
                ...VALUE_TRIGGER_CHARACTERS,
                ...SELECTOR_TRIGGER_CHARACTERS,
                ...QUERY_TRIGGER_CHARACTERS,
                DECLARATION_SEPARATOR_TRIGGER_CHARACTER,
                AT_TRIGGER_CHARACTER,
                GROUP_TRIGGER_CHARACTER
            ])
        ]
    },
    colorProvider: true,
    hoverProvider: true,
    workspace: {
        workspaceFolders: {
            supported: true
        }
    }
};

exports.AT_TRIGGER_CHARACTER = AT_TRIGGER_CHARACTER;
exports.DECLARATION_SEPARATOR_TRIGGER_CHARACTER = DECLARATION_SEPARATOR_TRIGGER_CHARACTER;
exports.GROUP_TRIGGER_CHARACTER = GROUP_TRIGGER_CHARACTER;
exports.INVOKED_TRIGGER_CHARACTERS = INVOKED_TRIGGER_CHARACTERS;
exports.QUERY_TRIGGER_CHARACTERS = QUERY_TRIGGER_CHARACTERS;
exports.SELECTOR_TRIGGER_CHARACTERS = SELECTOR_TRIGGER_CHARACTERS;
exports.SERVER_CAPABILITIES = SERVER_CAPABILITIES;
exports.VALUE_TRIGGER_CHARACTERS = VALUE_TRIGGER_CHARACTERS;
