import { MasterCSS } from '@master/css';
import EventEmitter from 'node:events';
import type { Position } from 'vscode-languageserver-protocol';
import { type Settings } from './settings';
import inspectSyntax from './features/inspect-syntax';
import renderSyntaxColors from './features/render-syntax-colors';
import editSyntaxColors from './features/edit-syntax-colors';
import suggestSyntax from './features/suggest-syntax';
import { TextDocument } from 'vscode-languageserver-textdocument';
export interface ClassPosition {
    range: {
        start: number;
        end: number;
    };
    raw: string;
    token: string;
}
export default class CSSLanguageService extends EventEmitter {
    customSettings?: Settings | undefined;
    css: MasterCSS;
    settings: Settings;
    constructor(customSettings?: Settings | undefined);
    inspectSyntax(...params: Parameters<typeof inspectSyntax>): import("vscode-languageserver-protocol").Hover | undefined;
    renderSyntaxColors(...params: Parameters<typeof renderSyntaxColors>): Promise<import("vscode-languageserver-protocol").ColorInformation[] | undefined> | undefined;
    editSyntaxColors(...params: Parameters<typeof editSyntaxColors>): import("vscode-languageserver-protocol").ColorPresentation[] | undefined;
    suggestSyntax(...params: Parameters<typeof suggestSyntax>): import("vscode-languageserver-protocol").CompletionItem[] | undefined;
    getClassPosition(textDocument: TextDocument, position: Position): ClassPosition | undefined;
    isDocumentAccepted(doc: TextDocument): boolean;
}
