import cssDataProvider from './css-data-provider.mjs';

function getUtilityInfo(EachRule, css = new MasterCSS()) {
    const nativeProperties = cssDataProvider.provideProperties();
    const declarations = EachRule.definition.declarations;
    const propsLength = Object.keys(declarations || {}).length;
    const propName = Object.keys(declarations || {})[0];
    const propValue = declarations?.[propName];
    let data;
    let detail;
    /**
     * Remaps to native CSS properties when only one property is declared
     * */ if (propsLength === 1) {
        const nativeCSSPropertyData = nativeProperties.find(({ name })=>name === propName);
        data = nativeCSSPropertyData?.values?.find(({ name })=>name === propValue || name.replace(/^-(ms|moz)-/, '') === propValue);
        if (data) {
            detail = `${propName}: ${propValue}`;
        } else {
            data = nativeCSSPropertyData;
            detail = nativeCSSPropertyData?.syntax;
        }
    }
    return {
        docs: '/reference/' + (data ? propName : 'utilities'),
        data,
        detail
    };
}

export { getUtilityInfo as default };
